=== test/feature/CMakeLists.txt ===
project( "feature test suite" )

cmake_minimum_required( VERSION 3.1.0 FATAL_ERROR )

#
# Configuration
#
set( SOURCE_DIR "source" )
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCATCH_CONFIG_MAIN" )

include_directories( SYSTEM ${catch_INCLUDE} ${asio_INCLUDE} )

#
# Build
#
add_executable( publishing_single_path_resources_http_get_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_get.cpp )
target_link_libraries( publishing_single_path_resources_http_get_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_get_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_get_feature_test_suite )

add_executable( publishing_single_path_resources_http_put_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_put.cpp )
target_link_libraries( publishing_single_path_resources_http_put_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_put_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_put_feature_test_suite )

add_executable( publishing_single_path_resources_http_head_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_head.cpp )
target_link_libraries( publishing_single_path_resources_http_head_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_head_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_head_feature_test_suite )

add_executable( publishing_single_path_resources_http_post_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_post.cpp )
target_link_libraries( publishing_single_path_resources_http_post_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_post_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_post_feature_test_suite )

add_executable( publishing_single_path_resources_http_trace_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_trace.cpp )
target_link_libraries( publishing_single_path_resources_http_trace_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_trace_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_trace_feature_test_suite )

add_executable( publishing_single_path_resources_http_patch_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_patch.cpp )
target_link_libraries( publishing_single_path_resources_http_patch_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_patch_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_patch_feature_test_suite )

add_executable( publishing_single_path_resources_http_delete_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_delete.cpp )
target_link_libraries( publishing_single_path_resources_http_delete_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_delete_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_delete_feature_test_suite )

add_executable( publishing_single_path_resources_http_connect_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_connect.cpp )
target_link_libraries( publishing_single_path_resources_http_connect_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_connect_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_connect_feature_test_suite )

add_executable( publishing_single_path_resources_http_options_feature_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_options.cpp )
target_link_libraries( publishing_single_path_resources_http_options_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_single_path_resources_http_options_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_options_feature_test_suite )

add_executable( publishing_multi_path_resources_http_get_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_get.cpp )
target_link_libraries( publishing_multi_path_resources_http_get_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_get_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_get_feature_test_suite )

add_executable( publishing_multi_path_resources_http_put_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_put.cpp )
target_link_libraries( publishing_multi_path_resources_http_put_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_put_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_put_feature_test_suite )

add_executable( publishing_multi_path_resources_http_head_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_head.cpp )
target_link_libraries( publishing_multi_path_resources_http_head_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_head_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_head_feature_test_suite )

add_executable( publishing_multi_path_resources_http_post_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_post.cpp )
target_link_libraries( publishing_multi_path_resources_http_post_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_post_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_post_feature_test_suite )

add_executable( publishing_multi_path_resources_http_trace_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_trace.cpp )
target_link_libraries( publishing_multi_path_resources_http_trace_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_trace_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_trace_feature_test_suite )

add_executable( publishing_multi_path_resources_http_patch_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_patch.cpp )
target_link_libraries( publishing_multi_path_resources_http_patch_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_patch_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_patch_feature_test_suite )

add_executable( publishing_multi_path_resources_http_delete_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_delete.cpp )
target_link_libraries( publishing_multi_path_resources_http_delete_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_delete_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_delete_feature_test_suite )

add_executable( publishing_multi_path_resources_http_connect_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_connect.cpp )
target_link_libraries( publishing_multi_path_resources_http_connect_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_connect_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_connect_feature_test_suite )

add_executable( publishing_multi_path_resources_http_options_feature_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_options.cpp )
target_link_libraries( publishing_multi_path_resources_http_options_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( publishing_multi_path_resources_http_options_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_options_feature_test_suite )

add_executable( custom_http_methods_http_get_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_get.cpp )
target_link_libraries( custom_http_methods_http_get_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_get_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_get_feature_test_suite )

add_executable( custom_http_methods_http_put_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_put.cpp )
target_link_libraries( custom_http_methods_http_put_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_put_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_put_feature_test_suite )

add_executable( custom_http_methods_http_head_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_head.cpp )
target_link_libraries( custom_http_methods_http_head_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_head_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_head_feature_test_suite )

add_executable( custom_http_methods_http_post_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_post.cpp )
target_link_libraries( custom_http_methods_http_post_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_post_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_post_feature_test_suite )

add_executable( custom_http_methods_http_trace_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_trace.cpp )
target_link_libraries( custom_http_methods_http_trace_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_trace_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_trace_feature_test_suite )

add_executable( custom_http_methods_http_patch_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_patch.cpp )
target_link_libraries( custom_http_methods_http_patch_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_patch_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_patch_feature_test_suite )

add_executable( custom_http_methods_http_delete_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_delete.cpp )
target_link_libraries( custom_http_methods_http_delete_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_delete_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_delete_feature_test_suite )

add_executable( custom_http_methods_http_connect_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_connect.cpp )
target_link_libraries( custom_http_methods_http_connect_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_connect_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_connect_feature_test_suite )

add_executable( custom_http_methods_http_options_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_options.cpp )
target_link_libraries( custom_http_methods_http_options_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_options_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_options_feature_test_suite )

add_executable( custom_http_methods_http_invoke_feature_test_suite ${SOURCE_DIR}/custom_http_methods/http_invoke.cpp )
target_link_libraries( custom_http_methods_http_invoke_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( custom_http_methods_http_invoke_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_invoke_feature_test_suite )

add_executable( http_method_handlers_http_get_feature_test_suite ${SOURCE_DIR}/http_method_handlers/http_get.cpp )
target_link_libraries( http_method_handlers_http_get_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( http_method_handlers_http_get_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/http_method_handlers_http_get_feature_test_suite )

add_executable( http_method_handlers_http_put_feature_test_suite ${SOURCE_DIR}/http_method_handlers/http_put.cpp )
target_link_libraries( http_method_handlers_http_put_feature_test_suite ${STATIC_LIBRARY_NAME} )
add_test( http_method_handlers_http_put_feature_test_suite ${EXECUTABLE_OUTPUT_PATH}/http_method_handlers_http_put_feature_test_suite )
